#include <miesun.h>

double DSun        //declinazione del sole in radianti
double latitud;    //latitudine in gradi
double longitud;   //longitudine in gradi
double FusoOrario; //Fuso Orario (italia -1) in ore
double ET;         //Equazione del tempo in minuti
double alfa;       //Ascensione Retta del Sole
double DSun;       //Declinazione del Sole
double HOrario;    //Angolo Orario del Sole


//
//        by Diego Bonata 1997
//
// FUNZIONE      : JD
// VAR.PASSATE   : (double) anno, mese, giorno
// VAR.RESTITUITE: (double) giorno giuliano
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di calcolo del giorno giuliano
double JD (double dat,double mese,double giorno)
{
double   year=dat;
double   a, b, y, m, h, h1, j, j1, risult;

 if (mese>2) {
    y = year;    m = mese;
 }
 else if (mese==1 || mese==2) {
    y = year - 1;
    m = mese + 12;
 }
 a = (int)y/100;
 b = (int)a/4;
 b = 2 - a + b;
 j = 365*y;
 j1= (int)y/4;
 j = j + j1;

 h  = 306001*(m+1)/10000;
 h1 = (int)h;

 risult = j + h1 + giorno + 1720994.5 + b;

return(risult);
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : jtog
// VAR.PASSATE   : (double) giorno giuliano
// VAR.RESTITUITE: (int) mese, giorno, ora, minuti
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di calcolo di mese,giorno,ora,minutinoto il giorno giuliano
void jtog(double jd,int *m,int *g,int *h,int *mi)
{
register double jdl_dec,jdl_dec1,Day,fraz;
register long int jdl_int,ausA,ausB=0,ausC,ausD,ausE;
register int H,Mon,Yea;

 jdl_int  = (long int)jd;
 jdl_dec1 = jdl_int;
 jdl_dec  = jd - (double)jdl_int + 0.5;

 if (jd>=0.5 && jd<=2.5) {
    if (jd<1.5) { *g = 0;    *m = 0;}
    else        { *g = 1;    *m = 0;}
 }
 else {
    if (jdl_dec>=1) {
	jdl_dec = jdl_dec -1;
	jdl_int = jdl_int +1;
    }
    ausB = jdl_int;
    if (jdl_int>2299160) {
	ausA = (long int)((jdl_dec1 - 1867216.25)/36524.25);
	ausB = jdl_int + 1 + ausA - ausA/4;
    }
    ausC = ausB + 1524;
    ausD = (long int)((ausC - 122.1)/365.25);
    ausE = (long int)(ausD * 365.25);
    H    = (int)((ausC - ausE)/30.6001);

    *g  = ausC - ausE + (int)(jdl_dec) - (int)(30.6001*H);
    *m  = (int)H - 1;
    if (H>=13.5)    *m = H - 13;
 }

 fraz = jdl_dec - (int)jdl_dec;
 *h   = (int)(fraz * 24);
 if ((fraz * 24 - *h)>0.958) {
    *h  = *h +1;
    *mi = 0;
 }
 else {
     fraz = fraz * 24 - *h;
     *mi  = (int)(fraz * 60);
     if ((fraz * 60 - *mi)>.5) *mi = *mi + 1;
 }
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : sortra
// VAR.PASSATE   : (float) Yeasr,Month,Day= anno, mese, giorno
// VAR.RESTITUITE: (float) *sorge   = ora del sorgere del sole in ore
//                 (float) *tramonta= ora del tramonto del sole in ore
// INCLUDE       : miemath.h
// DESCRIZIONE   :
// Routile di CALCOLO DELL' ORA DEL SORGERE E DEL TRAMONTO: NON PORTABILE
// Valori inseriti nelle variabili sorge, tramonta
void sortra(float Year,float Month,float Day,float *sorge,float *tramonta)
{
double JDF,T,JDFF;
float TSR,TSS,TR,TS,DH;
float R,B,X,X1,X2,CU1;
float D=.99727,PG=3.14159265359;

 JDFF=JD(Year,Month,Day);
 calcola_posizione_sole(JDFF,0.0,1);
 JDF=JD(Year-1,12.0,31.0);

 T=CalcT(JDF);
 R=6.6460656+(2400.05126*T)+(2.581E-05*T*T);
 R=R-(24*(Year-1900));
 B=24-R;
 if (B<0)  while (B<0) B=B+24;
 if (B>24) while (B>24)B=B-24;

 CU1=(JDFF-JDF)*.0657098-B;
 if (CU1<0) while (CU1<0) CU1=CU1+24;

 X1=-tan(DSun)*tan(GtoR(latitud));
 if (fabs(X1)>1) {
       //   Se uno di questi casi il sole o sempre sopra o sempre sotto l' orizzonte
       //	  IF latitud>0 AND DEC>0 THEN Sempre visibile
       //	  IF latitud>0 AND DEC<0 THEN Mai    visibile
       //	  IF latitud<0 AND DEC<0 THEN Sempre visibile
       //	  IF latitud<0 AND DEC>0 THEN Mai    visibile
 }
 else {
	 X2=sqrt(1-X1*X1);
	 if     (X1==0 && X2<0) X = -PG/2;
	 else if(X1==0 && X2>0) X =  PG/2;
	 else                   X = atan(X2/X1);
	 if (X2>0 && X1>0)     X=X;
	 if (X2>0 && X1<0)     X=X+PG;
	 if (X2<0 && X1<0)     X=X+PG;
	 if (X2<0 && X1>0)     X=X+2*PG;

	 TSR=-(X*180/PG)/15+24+GtoH(alfa);
	 if (TSR>24) while(TSR>24) TSR=TSR-24;
	 if (TSR<0)  while(TSR<0)  TSR=TSR+24;
	 TSS=(X*180/PG)/15+GtoH(alfa);
	 if (TSS>24) while(TSS>24) TSS=TSS-24;
	 if (TSS<0)  while(TSS<0)  TSS=TSS+24;

	 DH=(34/(15*cos(GtoR(latitud))*cos(DSun)*sin(X)));
	 TR=TSR-DH/60;
	 TS=TSS+DH/60;
	 if (TS>24)  while(TS>24)  TS=TS-24;
	 if (TS<0)   while(TS<0)   TS=TS+24;
	 if (TR>24)  while(TR>24)  TR=TR-24;
	 if (TR<0)   while(TR<0)   TR=TR+24;
	 *sorge    =TR-CU1;
	 *tramonta =TS-CU1;
	 if (*sorge<0)  while(*sorge<0)  *sorge=*sorge+24;
	 if (*sorge>24) while(*sorge>24) *sorge=*sorge-24;
	 if (*tramonta<0)  while(*tramonta<0)  *tramonta=*tramonta+24;
	 if (*tramonta>24) while(*tramonta>24) *tramonta=*tramonta-24;
	 if (longitud==(HtoG(FusoOrario))) {
		*sorge    = *sorge*D    + GtoH(longitud) - FusoOrario;
		*tramonta = *tramonta*D + GtoH(longitud) - FusoOrario;
	 }
	 else {
		*sorge    = *sorge    *D - (-longitud+HtoG(FusoOrario))/15;
		*tramonta = *tramonta *D - (-longitud+HtoG(FusoOrario))/15;
	 }
 }  //fine else se sole sorge tramonta
} // fine funzione sortra


//
//        by Diego Bonata 1997
//
// FUNZIONE      : sortra
// VAR.PASSATE   : (double) jday = giorno giuliano per la data desiderata
//                 (double) ora  = ora desiderata
//                 (int) f_ET    = Flag di selezione se f_ET= 2 calcola
//                 l'Equazione del tempo in caso contrario le coord. del Sole
// VAR.RESTITUITE: (double) ET   = Equazione del Tempo in minuti (se f_ET=2)
//                 (double) alfa = Ascensione Retta del sole
//                 (double) DSun = Declinazione del sole
//                 (double) HOrario = Angolo Orario del sole
// INCLUDE       : miemath.h
// DESCRIZIONE   :
// Calcolo delle coordinate del sole e dell'Equazione del tempo del sole
// in un determinato istante
// FUNZIONI DI SUPPORTO: CalcT, LongMed, AnoMed, Centro, CalcOmega, LongApp
// CalcObli, Eccentric, CalcSidTime, ConvHO
void calcola_posizione_sole(register double jday,double ora,int f_ET)
{
register double  T, SidTime;
register double  AMs, LMs;
register double  EC, CS, Obli, y;
register double  LVs, LAs;
register double  a1, a2, AVs, omega;
register float   LMerid;

 T = CalcT (jday+ora/24);
 LMs = Riduci (LongMed (T));
 AMs = GtoR (Riduci (AnoMed (T)));
 CS  = Riduci(Centro (AMs,T));
 LVs = Riduci (LMs+CS);
 omega= GtoR (Riduci (CalcOmega (T)));
 LAs = Riduci (LongApp (LVs,omega));
 Obli= GtoR (CalcObli (omega,T));
/* se lemniscata calcola eq tempo ed esci */
 if (f_ET==2) {
    EC= Eccentric (T);
    y = tan (Obli/2) * tan (Obli/2);
    LMs = GtoR (LMs);
    ET= y*sin(2*LMs)-2*EC*sin(AMs)+4*y*EC*sin(AMs)*cos(2*LMs)-y*y/2*sin(4*LMs)-5/4*EC*EC*sin(2*AMs);
    ET= GtoH (RtoG (ET));
    return;
 }
 else {
    if (LAs==90 || LAs==270) {
       if (LAs==90) alfa=90;
       else alfa=270;
       LAs= GtoR (LAs);
    }
    else {
       LAs= GtoR (LAs);
       a1=sin (LAs);
       a2=cos (LAs);
       alfa = RtoG (atan (cos (Obli) * a1 /a2));
       alfa= cambia_quadr(alfa,a1,a2);

    }
    DSun = asin (sin (Obli) * sin (LAs));
    SidTime = CalcSidTime (CalcT (jday),ora);
    if (SidTime>=24) SidTime = SidTime - 24;
    HOrario = HtoG(SidTime) - alfa;
    if (HOrario<=-360)  HOrario = HOrario + 360;
    ConvHO(ora);
 }
}

double CalcT (double jday)
{
 return((jday - 2415020.0)/36525);
}

//Longitudine media del sole
double LongMed (register double T)
{
 return(279.69668 + 36000.76892 *T + 0.0003025 *(T*T));
}

//Anomalia Media del sole
double AnoMed (register double T)
{
 return (358.47583 + 35999.04975 *T - 0.000150 *(T*T) - 0.0000033 *(T*T*T));
}

//Eccentricit
double Eccentric (register double T)
{
 return (0.01675104 - 0.0000418 *T - 0.000000126 *T*T);
}

//Centro
double Centro (register double AM,register double T)
{
register double senM,sen2M,sen3M,cs;

 senM = sin (AM);
 sen2M = sin (AM*2);
 sen3M = sin (AM*3);
 cs = (1.919460 - 0.004789 *T - 0.000014 *(T*T)) * senM;
 cs = cs + (0.020094 - 0.000100 *T) * sen2M;
 cs = cs + 0.000293 * sen3M;
 return (cs);
}

double CalcOmega (register double T)
{
 return (259.18 - 1934.142 *T);
}

//Longitudine apparente del sole
double LongApp (register double LVs, register double omega)
{
 return (LVs - 0.00569 - 0.00479 *sin (omega));
}

//Obliquit dell'eclittica
double CalcObli (register double omega, register double T)
{
register double obli;

 obli = 23.452294 - 0.0130125 *T - 0.00000164 *T*T + 0.000000503 *T*T*T;
 obli = obli +0.00256 *cos (omega);

 return (obli);
}

//rende giusto il valore di HOrario
void ConvHO(double ora)
{
double suporas,suporag;
float  LMerid  = HtoG(FusoOrario) - longitud;

suporas=HtoG(ora-12)+8;
suporag=HtoG(ora-12)-8;
if (scelta[3]<2)  LMerid=0;

 if (HOrario<suporag+LMerid || HOrario>suporas+LMerid) {//tutti gli altri casi OK
    if (suporas-8+LMerid>=0) {
	if (HOrario>0) HOrario=-(360-HOrario); //interviene se ora Circa 12 e 21/3 o 22/9
	else           HOrario=360+HOrario;  //interviene se ora>12 e HOrario<0
    }
    else if (suporas-8+LMerid<0){
	if (HOrario>0) HOrario=-(360-HOrario); //interviene se ora<12 e HOrario>0
	else printf("HOrario non previsto: vedi ConvHO"); //non interviene mai comunque da un segno
    }
 }
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : CalcSidTime
// VAR.PASSATE   : (double) T   = secoli giuliani calcolati mediante il
//                 giorno giuliano con CalcT
//                 (double) ora = ora desiderata
// VAR.RESTITUITE: (double) Ora Siderale
// INCLUDE       : miemath.h
// DESCRIZIONE   :
// Calcolo del Tempo Siderale per l'ora desiderata
double CalcSidTime (register double T, double ora)
{
register double Sidtime;
register double ipart;

 Sidtime = 0.276919398 + 100.0021359*T + 0.000001075*T*T;
 ipart=(int)Sidtime;
 Sidtime = (Sidtime - ipart)* 24;
 Sidtime = Sidtime + ora * 1.002737908;

 return (Sidtime);
}
